{{#> main_layout}}
  {{#*inline "head_scripts"}}
  <script src="/scripts/core.js"></script>
  <script src="/scripts/fido-util.js"></script>
  <script src="/scripts/management.js"></script>
  {{/inline}}

  {{#*inline "prompt_body"}}
    <p class="text-center">
      <code>{{username}}</code>
    </p>

    {{#each fido2_devices}}
    <div class="card w-100">
      <div class="row no-gutters">
        <div style="width: 90px;">
          <div class="card-body">
            <img src="/media/passkey.png" aria-hidden="false"r style="width: 64px;">
          </div>
        </div>
        <div class="col">
          <div class="card-body">
            <strong>{{display_name}}</strong>
            {{#if is_synced}}
            <small class="text-success">
              [synced]
            </small>
            {{/if}}
            <br>
            <small class="text-muted">
              Created {{create_date}}
            </small><br>
            {{#if can_delete}}
            <form method="post" class="mb-0">
              <input type="hidden" name="device_id" value="{{device_id}}">
              
              <button
                type="submit"
                class="btn btn-link"
                name="action"
                value="delete_fido2"
                style="padding: 0px;"
              >Remove</button>
            </form>
            {{/if}}
          </div>
        </div>
      </div>
    </div>
    {{/each}}

    {{#each uaf_devices}}
    <div class="card w-100">
      <div class="row no-gutters">
        <div style="width: 90px;">
          <div class="card-body">
            <img src="/media/mobile.png" aria-hidden="false" style="width: 64px;">
          </div>
        </div>
        <div class="col">
          <div class="card-body">
            <strong>{{display_name}}</strong><br>
            <small class="text-muted">
              Created {{create_date}}
            </small>
            {{#if can_delete}}
            <form method="post" class="mb-0">
              <input type="hidden" name="device_id" value="{{device_id}}">
              
              <button
                type="submit"
                class="btn btn-link"
                name="action"
                value="delete_uaf"
                style="padding: 0px;"
              >Remove</button>
            </form>
            {{/if}}
          </div>
        </div>
      </div>
    </div>
    {{/each}}

    <div style="margin-top: 10px;">
      <form method="post">
        <button
          type="button"
          id="add-passkey-button"
          class="btn btn-block branded-button"
        >
          Add a Passkey
        </button>
        {{#if uaf_enabled}}
        <button
          type="button"
          id="add-uaf-button"
          class="btn btn-block branded-button"
        >
          Add a {{uaf_app_name}} device
        </button>
        {{/if}}
        <button
          type="submit"
          class="btn btn-block btn-secondary"
          name="action"
          value="done"
        >
          Done
        </button>
      </form>
    </div>
  {{/inline}}

  {{#*inline "below_prompt"}}

    {{#if uaf_enabled}}
    <!-- UAF modal -->
    <div class="modal fade" id="uaf_model" tabindex="-1" role="dialog" aria-labelledby="uaf_model_title" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="uaf_model_title">Add a {{uaf_app_name}} device</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body text-center">
            <div id="qr-code-section" hidden>
              <p>Scan the QR code to pair your device</p>
              <img
                id="qr-code-image"
                alt="QR code"
                src=""
                style="height: 200px; width: 200px"
              />
            </div>
            <div id="pending-section" hidden>
              <p>Waiting for your registration to complete...</p>
            </div>
            <div id="timeout-section" hidden>
              <p>The user cancelled in the app or something took too long.</p>
              <p>Close this dialog and try again.</p>
            </div>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
          </div>
        </div>
      </div>
    </div>
    {{/if}}

  {{/inline}}
  
  {{#*inline "body_scripts"}}
  <script>
    const username = "{{username}}";
    const BASE_URL = "{{BASE_URL}}";

    window.addEventListener("load", function () {
      // variables
      let uafAbortController;

      // UI elements

      const errorMessageContainer = document.getElementById("error-message");
      const addPasskeyButton = document.getElementById("add-passkey-button");
      {{#if uaf_enabled}}
      const addUafButton = document.getElementById("add-uaf-button");
      {{/if}}
      const deleteFido2Buttons = document.querySelectorAll("button[value='delete_fido2']");
      const deleteUafButtons = document.querySelectorAll("button[value='delete_uaf']");
      const uafQrCodeSection = document.getElementById("qr-code-section");
      const uafQrCodeImage = document.getElementById("qr-code-image");
      const uafPendingSection = document.getElementById("pending-section");
      const uafTimeoutSection = document.getElementById("timeout-section");

      // helpers

      function showElement(element) {
        element.removeAttribute("hidden");
      }

      function hideElement(element) {
        if (!element.attributes.getNamedItem("hidden")) {
          element.setAttribute("hidden", "");
        }
      }

      function enableElement(element) {
        element.disabled = false;
      }

      function disableElement(element) {
        element.disabled = true;
      }

      function displayError(err) {
        errorMessageContainer.innerText =
          err.policy || err.description || err.message || err;
        showElement(errorMessageContainer);
      }

      async function passkeySignUp() {
        hideElement(errorMessageContainer);
        const button = this;
        disableElement(button);

        let result;
        try {
          result = await registerPasskey({
            rpBaseUrl: BASE_URL,
            username,
            displayName: username,
          });
        } catch (err) {
          enableElement(button);
          if (err.name === "NotAllowedError") {
            return displayError(
              "There was an issue enrolling your passkey"
            );
          }
          return displayError(err);
        }

        // sync Auth0 with HYPR and refresh page
        await syncDevices({ rpBaseUrl: BASE_URL });
        window.location.reload();
      }    

      async function uafSignUp() {
        hideElement(errorMessageContainer);
        uafAbortController = new AbortController();

        let result;
        try {
          result = await registerUaf({
            rpBaseUrl: BASE_URL,
            username,
            displayQrCode: (qrCodeDataUrl) => {
              uafQrCodeImage.src = qrCodeDataUrl;
              $("#uaf_model").modal("show");
              showElement(uafQrCodeSection);
              hideElement(uafPendingSection);
              hideElement(uafTimeoutSection);
            },
            displayPendingMessage: () => {
              hideElement(uafQrCodeSection);
              showElement(uafPendingSection);
              hideElement(uafTimeoutSection);
            },
            displayTimeoutMessage: () => {
              hideElement(uafQrCodeSection);
              hideElement(uafPendingSection);
              showElement(uafTimeoutSection);
            },
            abortSignal: uafAbortController.signal
          });
        }
        catch (err) {
          return displayError(err);
        }

        if (result && result.username === username) {
          await syncDevices({ rpBaseUrl: BASE_URL });
          window.location.reload();
        }
      }

      // Wire up UI events

      addPasskeyButton.addEventListener("click", passkeySignUp);
      {{#if uaf_enabled}}
      addUafButton.addEventListener("click", uafSignUp);
      $("#uaf_model").on("hide.bs.modal", () => {
        uafAbortController.abort();
      });
      {{/if}}

      for (const button of deleteFido2Buttons) {
        button.addEventListener("click", (event) => {
          const message = deleteFido2Buttons.length === 1
          ?
            "Are you sure you want to delete your ONLY passkey?\n\n" + 
            "If you continue, you will only be able to sign in with your password" +
            (deleteUafButtons.length > 0 ? " or a {{uaf_app_name}} device" : "") + ".\n\n" +
            "You should also delete the passkey from its device or platform."
          :
            "Are you sure you want to remove this passkey?\n\n" + 
            "If you continue, you should also delete the passkey from its device or platform.";
          const doDelete = window.confirm(message);

          if (!doDelete) {
            console.log("Passkey not deleted");
            // cancel the form submit
            event.preventDefault();
          }
        });
      }

      for (const button of deleteUafButtons) {
        button.addEventListener("click", (event) => {
          const message = deleteUafButtons.length === 1
          ?
            "Are you sure you want to delete your ONLY {{uaf_app_name}} device?\n\n" + 
            "If you continue, you will only be able to sign in with your password" +
            (deleteFido2Buttons.length > 0 ? " or a passkey" : "") + ".\n"
          :
            "Are you sure you want to remove this {{uaf_app_name}} device?";
          const doDelete = window.confirm(message);

          if (!doDelete) {
            console.log("UAF device not deleted");
            // cancel the form submit
            event.preventDefault();
          }
        });
      }
    });
  </script>
  {{/inline}}
{{/main_layout}}
